// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from autoware_map_msgs:msg/MapProjectorInfo.idl
// generated code does not contain a copyright notice

#include "autoware_map_msgs/msg/detail/map_projector_info__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_autoware_map_msgs
const rosidl_type_hash_t *
autoware_map_msgs__msg__MapProjectorInfo__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x12, 0xf9, 0x3c, 0x94, 0x9b, 0xda, 0x2f, 0x37,
      0x95, 0xe7, 0x56, 0x9e, 0xc6, 0x47, 0xd5, 0xc4,
      0x2b, 0xc5, 0x93, 0xb7, 0xd0, 0x83, 0x7c, 0xe5,
      0x2c, 0xaf, 0x21, 0x0f, 0x2f, 0x7c, 0x53, 0x01,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types
#include "geographic_msgs/msg/detail/geo_point__functions.h"

// Hashes for external referenced types
#ifndef NDEBUG
static const rosidl_type_hash_t geographic_msgs__msg__GeoPoint__EXPECTED_HASH = {1, {
    0x60, 0x2c, 0x64, 0x7c, 0xf8, 0x7b, 0xbe, 0x95,
    0xa0, 0x23, 0x1b, 0x45, 0x9b, 0x5a, 0xc3, 0x00,
    0x51, 0x87, 0x5d, 0x07, 0xc0, 0xc7, 0x40, 0xb3,
    0x1a, 0xd7, 0xa8, 0xc4, 0x66, 0x2b, 0x97, 0x1e,
  }};
#endif

static char autoware_map_msgs__msg__MapProjectorInfo__TYPE_NAME[] = "autoware_map_msgs/msg/MapProjectorInfo";
static char geographic_msgs__msg__GeoPoint__TYPE_NAME[] = "geographic_msgs/msg/GeoPoint";

// Define type names, field names, and default values
static char autoware_map_msgs__msg__MapProjectorInfo__FIELD_NAME__projector_type[] = "projector_type";
static char autoware_map_msgs__msg__MapProjectorInfo__FIELD_NAME__vertical_datum[] = "vertical_datum";
static char autoware_map_msgs__msg__MapProjectorInfo__FIELD_NAME__mgrs_grid[] = "mgrs_grid";
static char autoware_map_msgs__msg__MapProjectorInfo__FIELD_NAME__map_origin[] = "map_origin";

static rosidl_runtime_c__type_description__Field autoware_map_msgs__msg__MapProjectorInfo__FIELDS[] = {
  {
    {autoware_map_msgs__msg__MapProjectorInfo__FIELD_NAME__projector_type, 14, 14},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_STRING,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {autoware_map_msgs__msg__MapProjectorInfo__FIELD_NAME__vertical_datum, 14, 14},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_STRING,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {autoware_map_msgs__msg__MapProjectorInfo__FIELD_NAME__mgrs_grid, 9, 9},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_STRING,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {autoware_map_msgs__msg__MapProjectorInfo__FIELD_NAME__map_origin, 10, 10},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_NESTED_TYPE,
      0,
      0,
      {geographic_msgs__msg__GeoPoint__TYPE_NAME, 28, 28},
    },
    {NULL, 0, 0},
  },
};

static rosidl_runtime_c__type_description__IndividualTypeDescription autoware_map_msgs__msg__MapProjectorInfo__REFERENCED_TYPE_DESCRIPTIONS[] = {
  {
    {geographic_msgs__msg__GeoPoint__TYPE_NAME, 28, 28},
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
autoware_map_msgs__msg__MapProjectorInfo__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {autoware_map_msgs__msg__MapProjectorInfo__TYPE_NAME, 38, 38},
      {autoware_map_msgs__msg__MapProjectorInfo__FIELDS, 4, 4},
    },
    {autoware_map_msgs__msg__MapProjectorInfo__REFERENCED_TYPE_DESCRIPTIONS, 1, 1},
  };
  if (!constructed) {
    assert(0 == memcmp(&geographic_msgs__msg__GeoPoint__EXPECTED_HASH, geographic_msgs__msg__GeoPoint__get_type_hash(NULL), sizeof(rosidl_type_hash_t)));
    description.referenced_type_descriptions.data[0].fields = geographic_msgs__msg__GeoPoint__get_type_description(NULL)->type_description.fields;
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# Projector type\n"
  "string LOCAL = \"Local\"\n"
  "string LOCAL_CARTESIAN_UTM = \"LocalCartesianUTM\"\n"
  "string MGRS = \"MGRS\"\n"
  "string TRANSVERSE_MERCATOR = \"TransverseMercator\"\n"
  "string projector_type\n"
  "\n"
  "# Vertical datum\n"
  "string WGS84 = \"WGS84\"\n"
  "string EGM2008 = \"EGM2008\"\n"
  "string vertical_datum\n"
  "\n"
  "# Used for MGRS map\n"
  "string mgrs_grid\n"
  "\n"
  "# Used for some map projection types\n"
  "# altitude may not be in ellipsoid height\n"
  "geographic_msgs/GeoPoint map_origin";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
autoware_map_msgs__msg__MapProjectorInfo__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {autoware_map_msgs__msg__MapProjectorInfo__TYPE_NAME, 38, 38},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 426, 426},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
autoware_map_msgs__msg__MapProjectorInfo__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[2];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 2, 2};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *autoware_map_msgs__msg__MapProjectorInfo__get_individual_type_description_source(NULL),
    sources[1] = *geographic_msgs__msg__GeoPoint__get_individual_type_description_source(NULL);
    constructed = true;
  }
  return &source_sequence;
}
